// Example file for Reidar Husmo's alphabet.
// Shows the currently available letters.

#include "colors.inc"
#include "textures.inc"
#include "shapes.inc"
#include "lettdefs.inc"

camera {
	location  <0  0 -5>
	look_at   <0  0  0.0>
	up        <0.0  1.0   0.0>
	right     <1.33 0.0   0.0>
}
object { light_source { <5 -10 -30> color White } }

#declare Letter_Texture = texture { Blue_Sky2 }

#declare abcdefg = composite {
	object {
		A
		texture { Letter_Texture }
		translate <0.0000 0 0>
	}
	object {
		B
		texture { Letter_Texture }
		translate <0.8400 0 0>
	}
	object {
		C
		texture { Letter_Texture }
		translate <1.5525 0 0>
	}
	object {
		D
		texture { Letter_Texture }
		translate <2.4525 0 0>
	}
	object {
		E
		texture { Letter_Texture }
		translate <3.2525 0 0>
	}
	object {
		F
		texture { Letter_Texture }
		translate <3.9525 0 0>
	}
	object {
		G
		texture { Letter_Texture }
		translate <4.6525 0 0>
	}
	translate <-2.72625 0 0> // centre around the y-axis
	// scale <0.36680 0.36680 0.36680> // scale to unit length
	bounded_by {
		box { UnitBox translate <0 1 0> scale <2.72625 1 0.1> }
	}
} // Accumulated length: 5.45250 half: 2.72625 inv: 0.183402

#declare hijklmn = composite {
	object {
		H
		texture { Letter_Texture }
		translate <0.0000 0 0>
	}
	object {
		I
		texture { Letter_Texture }
		translate <0.9000 0 0>
	}
	object {
		J
		texture { Letter_Texture }
		translate <1.2000 0 0>
	}
	object {
		K
		texture { Letter_Texture }
		translate <1.9250 0 0>
	}
	object {
		L
		texture { Letter_Texture }
		translate <2.8550 0 0>
	}
	object {
		M
		texture { Letter_Texture }
		translate <3.5550 0 0>
	}
	object {
		N
		texture { Letter_Texture }
		translate <4.7788 0 0>
	}
	translate <-2.83938 0 0> // centre around the y-axis
	// scale <0.35219 0.35219 0.35219> // scale to unit length
	bounded_by {
		box { UnitBox translate <0 1 0> scale <2.84 1 0.1> }
	}
} // Accumulated length: 5.67876 half: 2.83938 inv: 0.176095

#declare opqrstu = composite {
	object {
		O
		texture { Letter_Texture }
		translate <0.0000 0 0>
	}
	object {
		P
		texture { Letter_Texture }
		translate <0.9000 0 0>
	}
	object {
		Q
		texture { Letter_Texture }
		translate <1.6125 0 0>
	}
	object {
		R
		texture { Letter_Texture }
		translate <2.5125 0 0>
	}
	object {
		S
		texture { Letter_Texture }
		translate <3.2250 0 0>
	}
	object {
		T
		texture { Letter_Texture }
		translate <3.9500 0 0>
	}
	object {
		U
		texture { Letter_Texture }
		translate <4.6500 0 0>
	}
	translate <-2.63750 0 0> // centre around the y-axis
	// scale <0.37915 0.37915 0.37915> // scale to unit length
	bounded_by {
		box { UnitBox translate <0 1 0> scale <2.6375 1 0.1> }
	}
} // Accumulated length: 5.27500 half: 2.63750 inv: 0.189573

#declare vwxyz = composite {
	object {
		V
		texture { Letter_Texture }
		translate <0.0000 0 0>
	}
	object {
		W
		texture { Letter_Texture }
		translate <0.8400 0 0>
	}
	object {
		X
		texture { Letter_Texture }
		translate <1.9800 0 0>
	}
	object {
		Y
		texture { Letter_Texture }
		translate <2.8600 0 0>
	}
	object {
		Z
		texture { Letter_Texture }
		translate <3.7600 0 0>
	}
	translate <-2.28410 0 0> // centre around the y-axis
	// scale <0.43781 0.43781 0.43781> // scale to unit length
	bounded_by {
		box { UnitBox translate <0 1 0> scale <2.2841 1 0.1> }
	}
} // Accumulated length: 4.56820 half: 2.28410 inv: 0.218905

composite {
	composite { abcdefg translate <0 1.2 0> }
	composite { hijklmn translate <0 0.0 0> }
	composite { opqrstu translate <0 -1.2 0> }
	composite { vwxyz   translate <0 -2.4 0> }
}
