#include "shapes.inc"

//////////// Very basic shapes /////////////////////
#declare Vert_Bar =
	quadric {
		Cylinder_Y
		scale <0.1 1 0.1>
		translate <0.1 0 0>
	}

#declare Vert_Bar_2 =
	quadric {
		Cylinder_Y
		scale <0.1 1 0.1>
	}

#declare Hor_Bar =
	quadric {
		Cylinder_X
		scale <1.0 0.1 0.1>
		translate <0 0.1 0>
	}

#declare Hor_Bar_2 =
	quadric {
		Cylinder_X
		scale <1.0 0.1 0.1>
	}

////////////////////////////////////////////////////
// A B C D E F G I H J K L M N O P Q R S T U V X Y Z

//////////// derived, basic shapes /////////////////

// used for H I K
#declare Vert_Clipped_Bar =
	intersection {
		quadric { Vert_Bar }
		plane { <0 1 0> 1 }
		plane { <0 -1 0> 0 }
	}

// used for B E F H P R T - clip right end for correct length
#declare Hor_Clipped_Bar =
	intersection {
		quadric { Hor_Bar }
		plane { <-1 0 0> -0.1 }
	}

// used for B D E G L - clip right end for correct length
#declare Bottom_E =
	intersection {
		quadric { Hor_Bar }
		plane { <-1 1 0> 0 }
	}

// used for B D E F P R - clip right end for correct length
#declare Top_E =
	intersection {
		intersection { Bottom_E }
		rotate <180 0 0>
		translate <0 1 0>
	}

// used for B E F H P R - clip right end for correct length
#declare Centre_E =
	intersection {
		quadric { Hor_Bar_2 translate <0 0.5 0> }
		plane { <-1 0 0> -0.1 }
	}

// Used for F P R
#declare Vert_F_1 =
	intersection {
		quadric { Vert_Bar }
		plane { <1 1 0> 0 translate <0 1 0> }
	}
#declare Vert_F =
	intersection {
		intersection { Vert_F_1 }
		plane { <0 -1 0> 0 }
	}

// used for B D E
#declare Vert_E =
	intersection {
		intersection { Vert_F_1 }
		plane { <1 -1 0> 0 }
	}

////////////////////////////////////////////////////

//////////// complex basic shapes //////////////////

#declare D_Circle =
	quartic { /* R=0.4, r=0.1 torus */
			< 1.0   0.0   0.0    0.0     2.0   0.0   0.0   2.0   0.0 -0.34
			  0.0   0.0   0.0    0.0     0.0   0.0   0.0   0.0   0.0    0.0
			  1.0   0.0   0.0    2.0     0.0  0.30   0.0   0.0   0.0    0.0
			  1.0   0.0 -0.34   0.0   0.0225 >
		rotate <90 0 0>
		translate <0 0.5 0> // so now resting on x-axis
	}

// base for C G O Q
#declare Big_Torus_Radius = 0.4
#declare Big_Circle =
	quartic { /* R=0.3, r=0.1 torus */
			< 1.0   0.0   0.0    0.0     2.0   0.0   0.0   2.0   0.0 -0.2
			  0.0   0.0   0.0    0.0     0.0   0.0   0.0   0.0   0.0    0.0
			  1.0   0.0   0.0    2.0     0.0  0.16   0.0   0.0   0.0    0.0
			  1.0   0.0 -0.2   0.0   0.0064 >
		rotate <90 0 0>
		translate <0 0.4 0> // so now resting on x-axis
	}

// base for B (lower half) P R U
#declare Mid_Torus_Radius = 0.3125
#declare Mid_Circle =
	quartic { /* R=0.2125, r=0.1 torus */
			< 1.0   0.0   0.0    0.0     2.0   0.0   0.0   2.0   0.0 -0.1103125
			  0.0   0.0   0.0    0.0     0.0   0.0   0.0   0.0   0.0    0.0
			  1.0   0.0   0.0    2.0     0.0  0.07032   0.0   0.0   0.0    0.0
			  1.0   0.0 -0.1103125   0.0   0.00123596 >
		rotate <90 0 0>
		translate <0 0.3125 0> // so now resting on x-axis
	}

// base for B (upper half) J
#declare Small_Torus_Radius = 0.2875
#declare Small_Torus_Radius_1 = 0.7125
#declare Small_Circle =
	quartic { /* R=0.1875, r=0.1 torus */
			< 1.0   0.0   0.0    0.0     2.0   0.0   0.0   2.0   0.0 -0.09032
			  0.0   0.0   0.0    0.0     0.0   0.0   0.0   0.0   0.0    0.0
			  1.0   0.0   0.0    2.0     0.0  0.05032 0.0   0.0   0.0    0.0
			  1.0   0.0 -0.09032 0.0   0.0006330256 >
		rotate <90 0 0>
		translate <0 0.2825 0> // so now resting on x-axis
	}


// Base for V, W and A
#declare V_Shape = union {
	intersection {
		quadric {
			Hor_Bar  // right half
			rotate <0 0 70>
		}
		plane { <-1 0 0> 0 }
	}
	intersection {
		quadric {
			Hor_Bar  // left half
			rotate <0 0 -70>
		}
		plane { <1 0 0> 0 }
	}
}

// M_Base may be wrong - haven't checked it for a while
#declare M_Base =
	union {
		intersection {
			quadric { Vert_Bar }
			plane { <1 0 0> 0 rotate <0 0 20> translate <0 1 0> }
		}
		intersection {
			quadric { Vert_Bar rotate <0 0 140> translate <0 1 0> }
			plane { <-1 0 0> 0 rotate <0 0 20> translate <0 1 0> }
		}
	}

/*********** Now declare the letters... ***********/
#declare A = object {
	union {
		intersection {
			union {
				V_Shape
				rotate <180 0 0>
				translate <0 1 0>
			}
			plane { <0 -1 0> 0 }
		}
		intersection {
			quadric {
				Cylinder_X
				scale <0.1 0.1 0.1>
				translate <0 0.2 0>
			}
			plane { <0 1 0> -0.1
				rotate <0 0 -70>
				translate <0 1 0>
			}
			plane { <0 1 0> -0.1
				rotate <0 0 70>
				translate <0 1 0>
			}
		}
	}
	bounded_by {
		sphere { <0.0 0.5 0> 0.63 }
	}
	translate <0.37 0 0>
}

#declare B = object {
	union {
		intersection {
			union {
				intersection { Bottom_E }
				intersection { Top_E }
				intersection { Centre_E translate <0 0.025 0> }
			}
			plane { <1 0 0> 0.305 }
		}
		intersection {
			union {
				quartic { Mid_Circle translate <0.3 0 0> sturm }
				quartic { Small_Circle translate <0.3 0.425 0> sturm }
			}
			plane { <-1 0 0> -0.3 }
		}
		intersection { Vert_E }
	}
	bounded_by {
		sphere { <0.3 0.5 0> 0.6 }
	}
}

#declare C = object {
	union {
		intersection {
			quartic { Big_Circle translate <0.4 0.2 0> sturm }
			plane { <0 -1 0> -0.6 }
		}
		intersection {
			quartic { Big_Circle translate <0.4 0.0 0> sturm }
			plane { <0 1 0> 0.4 }
		}
		intersection {
			quadric { Vert_Bar }
			plane { <0 1 0> 0.605 }
			plane { <0 -1 0> -0.405 }
		}
	}
	bounded_by {
		sphere { <0.4 0.5 0> 0.6 }
	}
}

#declare D = object {
	union {
		intersection {
			union {
				intersection { Bottom_E }
				intersection { Top_E }
			}
			plane { <1 0 0> 0.21 }
		}
		intersection { Vert_E }
		intersection {
			quartic { D_Circle translate <0.2 0 0> sturm }
			plane { <-1 0 0> -0.2 }
		}
	}
	bounded_by {
		sphere { <0.3 0.5 0> 0.7 }
	}
}

#declare E = object {
	union {
		intersection {
			union {
				intersection { Bottom_E }
				intersection { Top_E }
			}
			plane { <1 0 0> 0.6 }
		}
		intersection {
			intersection { Centre_E }
			plane { <1 0 0> 0.5 }
		}
		intersection { Vert_E }
	}
	bounded_by {
		sphere { <0.3 0.5 0> 0.6 }
	}
}

#declare F = object {
	union {
		intersection {
			intersection { Top_E }
			plane { <1 0 0> 0.6 }
		}
		intersection {
			intersection { Centre_E }
			plane { <1 0 0> 0.5 }
		}
		intersection { Vert_F }
	}
	bounded_by {
		sphere { <0.3 0.5 0> 0.6 }
	}
}

// The G could do with a bit more work
#declare G = object {
	union {
		intersection {
			quartic { Big_Circle translate <0.4 0.2 0> sturm }
			plane { <0 -1 0> -0.6 }
		}
		intersection {
			quartic { Big_Circle translate <0.4 0.0 0> sturm }
			plane { <0 1 0> 0.4 }
		}
		intersection {
			quadric { Vert_Bar }
			plane { <0 1 0> 0.605 }
			plane { <0 -1 0> -0.405 }
		}
		intersection {
			quadric { Vert_Bar_2 translate <0.7 0 0> }
			plane { <0 1 0> 0 rotate <0 0 45> translate <0.8 0.5 0> }
			plane { <0 -1 0> -0.1 }
		}
		intersection {
			quadric { Hor_Bar_2 translate <0 0.4 0> }
			plane { <0 -1 0> 0 rotate <0 0 45> translate <0.8 0.5 0> }
			plane { <-1 0 0> -0.5 }
		}
	}
	bounded_by {
		sphere { <0.4 0.5 0> 0.7 }
	}
}

#declare H = object {
	intersection {
		union {
			intersection { Vert_Clipped_Bar }
			intersection { Vert_Clipped_Bar translate <0.6 0 0> }
			intersection {
				intersection { Centre_E }
				plane { <1 0 0> 0.7 }
			}
		}
		plane { <0 1 0> 1 }
		plane { <0 -1 0> 0 }
	}
	bounded_by {
		sphere { <0.4 0.5 0> 0.65 }
	}
}

#declare I = object {
	intersection {
		quadric { Vert_Bar }
		plane { <0 1 0> 1 }
		plane { <0 -1 0> 0 }
	}
	bounded_by {
		sphere { <0.1 0.5 0> 0.55 }
	}
}

#declare J = object {
	union {
		intersection {
			quadric { Vert_Bar translate <0.425 0 0> }
			plane { <0 1 0> 1 }
			plane { <0 -1 0> -0.3125 }
		}
		intersection {
			quartic { Mid_Circle translate <0.3125 0 0> sturm }
			plane { <0 1 0> 0.3125 }
		}
	}
	bounded_by {
		sphere { <0.3125 0.5 0> 0.6 }
	}
}

#declare K = object {
	intersection {
		union {
			quadric { Vert_Bar }
			intersection {   //   /-segment
				quadric {
					Cylinder_X
					scale <0.1 0.1 0.1>
					rotate <0 0 50>
					translate <0 0.2 0>
				}
				plane { <-1 0 0> -0.1 }
			}
			intersection {   // \-segment
				quadric {
					Cylinder_X
					scale <0.1 0.1 0.1>
					rotate <0 0 -60>
					translate <0.65 0 0>
				}
				plane {
					<0 1 0> 0
					rotate <0 0 50>
					translate <0 0.2 0>
				}
			}
		}
		plane { <0 1 0> 1 }
		plane { <0 -1 0> 0 }
	}
	bounded_by {
		sphere { <0.3 0.5 0> 0.7 }
	}
}

#declare L = object {
	union {
		intersection {
			quadric { Hor_Bar }
			plane { <-1 1 0> 0 }
			plane { <1 0 0> 0.6 }
		}
		intersection {
			quadric { Vert_Bar }
			plane { <1 -1 0> 0 }
			plane { <0 1 0> 1 }
		}
	}
	bounded_by {
		sphere { <0.3 0.5 0> 0.6 }
	}
}

#declare M = object {
	intersection {
		union {
			intersection {
				quadric {Cylinder_Y
					scale < .1  1  .1 >
					translate < -.46188   .5   0 >
				}
				plane {<0.0 1.0 0.0>  0 rotate <0 0 -60> translate <0 .2 0>}
			}
			intersection {
				quadric {Cylinder_Y
					scale < .1  1  .1 >
					translate < .46188   .5   0 >
				}
				plane {<0.0 1.0 0.0>  0 rotate <0 0 60> translate <0 .2 0>}
			}
			intersection {
				quadric { Cylinder_Y
					scale < .1  1  .1 >
					rotate <  0   0   30 >
					translate <  0   .2   0 >
				}
				plane {<-1.0 0.0 0.0>  0.46188 }
				plane {<1.0 0.0 0.0>  0.0 }
			}
			intersection {
				quadric { Cylinder_Y
					scale < .1  1  .1 >
					rotate <  0   0  -30 >
					translate <  0   .2   0 >
				}
				plane {<1.0 0.0 0.0>  0.46188 }
				plane {<-1.0 0.0 0.0>  0.0 }
			}
		}
		plane {<0 -1 0>  0 }
		plane {<0 1 0>  1 }
	}
	bounded_by { sphere { <0 0.5 -0.1> 0.832 } }
	translate <0.56188 0 0>
	//bounded_by { box { <0 0 -0.1> <1.12376 1 0.1> } }
}

// N with cross-bar at 60 degrees
// 1 / tan 50 = .8390096
// 1 / tan 55 = .7002075
// 1 / tan 60 = .57735027
#declare N = object {
	intersection {
		union {
			quadric { Vert_Bar }
			quadric { Vert_Bar_2 translate <0.8002075 0 0>}
			intersection {
				quadric { Vert_Bar_2 rotate <0 0 35> translate <0.1 1 0>}
				plane { <-1 0 0> -0.1 }
				plane { <1 0 0> 0.8002075 }
			}
		}
		plane { <0 1 0> 1 }
		plane { <0 -1 0> 0 }
	}
	bounded_by {
		sphere { <0.4 0.5 0> 0.8 }
	}
}

#declare O = object {
	union {
		intersection {
			quartic { Big_Circle translate <0.4 0.2 0> sturm }
			plane { <0 -1 0> -0.6 }
		}
		intersection {
			quartic { Big_Circle translate <0.4 0.0 0> sturm }
			plane { <0 1 0> 0.4 }
		}
		intersection {
			quadric { Vert_Bar }
			plane { <0 1 0> 0.6 }
			plane { <0 -1 0> -0.4 }
		}
		intersection {
			quadric { Vert_Bar translate <0.6 0 0> }
			plane { <0 1 0> 0.6 }
			plane { <0 -1 0> -0.4 }
		}
	}
	bounded_by {
		sphere { <0.4 0.5 0> 0.6 }
	}
}

#declare P = object {
	union {
		intersection {
			union {
				intersection { Top_E }
				intersection { Centre_E translate <0 -0.025 0> }
			}
			plane { <1 0 0> 0.301 }
		}
		intersection {
			quartic { Mid_Circle translate <0.3 0.375 0> sturm }
			plane { <-1 0 0> -0.3 }
		}
		intersection { Vert_F }
	}
	bounded_by {
		sphere { <0.3 0.5 0> 0.7 }
	}
}

#declare Q = object {
	union {
		intersection {
			quartic { Big_Circle translate <0.4 0.2 0> sturm }
			plane { <0 -1 0> -0.6 }
		}
		intersection {
			quartic { Big_Circle translate <0.4 0.0 0> sturm }
			plane { <0 1 0> 0.4 }
		}
		intersection {
			quadric { Vert_Bar }
			plane { <0 1 0> 0.6 }
			plane { <0 -1 0> -0.4 }
		}
		intersection {
			quadric { Vert_Bar translate <0.6 0 0> }
			plane { <0 1 0> 0.605 }
			plane { <0 -1 0> -0.405 }
		}
		intersection {
			quadric { Vert_Bar rotate <0 0 30> translate <0.6 0 0> }
			plane { <0 1 0> 0.38 }
			plane { <0 -1 0> 0 }
		}
	}
	bounded_by {
		sphere { <0.4 0.5 0> 0.6 }
	}
}

#declare R = object {
	union {
		intersection {
			union {
				intersection { Top_E }
				intersection { Centre_E translate <0 -0.025 0> }
			}
			plane { <1 0 0> 0.305 }
		}
		intersection {
			quartic { Mid_Circle translate <0.3 0.375 0> sturm }
			plane { <-1 0 0> -0.3 }
		}
		intersection {
			quadric {
				Cylinder_X
				scale <0.1 0.1 0.1>
				rotate <0 0 -65>
				translate <0.3 0.475 0>
			}
			plane { <0 1 0> 0.475 }
			plane { <0 -1 0> 0 }
		}
		intersection { Vert_F }
	}
	bounded_by {
		sphere { <0.3 0.5 0> 0.7 }
	}
}

#declare S = object {
	union {
		intersection {
			quartic { Mid_Circle translate <Mid_Torus_Radius 0 0> sturm }
			union {
				plane { <0 1 0> 0 translate <0 Mid_Torus_Radius 0> }
				plane { <-1 0 0> 0 translate <Mid_Torus_Radius 0 0> }
			}
		}
		intersection {
			quartic { Small_Circle translate <Mid_Torus_Radius 0.425 0> sturm }
//               quartic { Mid_Circle translate <0.2625 0 0> sturm }
			union {
				plane { <0 -1 0> 0 translate <0 Small_Torus_Radius_1 0> }
				plane { <1 0 0> 0 translate <Mid_Torus_Radius 0 0> }
			}
		}
	}
	bounded_by {
		sphere { <0.3 0.5 0> 0.6 }
	}
}

#declare T = object {
	union {
		intersection {
			quadric { Vert_Bar_2 translate <0.3 0 0> }
			plane { <0 1 0> 0.9 }
			plane { <0 -1 0> 0 }
		}
		intersection {
			quadric { Hor_Bar_2 translate <0 0.9 0> }
			plane { <-1 0 0> 0 }
			plane { <1 0 0> 0.6 }
		}
	}
	bounded_by {
		sphere { <0.3 0.5 0> 0.6 }
	}
}

#declare U = object {
	union {
		intersection {
			union {
				quadric { Vert_Bar }
				quadric { Vert_Bar translate <0.425 0 0> }
			}
			plane { <0 1 0> 1 }
			plane { <0 -1 0> -0.3125 }
		}
		intersection {
			quartic { Mid_Circle translate <0.3125 0 0> sturm }
			plane { <0 1 0> 0.3125 }
		}
	}
	bounded_by {
		sphere { <0.3125 0.5 0> 0.6 }
	}
}

#declare V = object {
	intersection {
		union { V_Shape }
		plane { <0 1 0> 1 }
	}
	bounded_by {
		sphere { <0.0 0.5 0> 0.65 }
	}
	translate <0.37 0 0>
}

#declare W = object {
	intersection {
		union {
			intersection {
				union {
					V_Shape
					translate <0.15 0 0>
				}
				plane { <-1 0 0> 0 }
			}
			intersection {
				union {
					V_Shape
					translate <-0.15 0 0>
				}
				plane { <1 0 0> 0 }
			}
		}
		plane { <0 1 0> 1 }
	}
	bounded_by {
		sphere { <0.0 0.5 0> 0.75 }
	}
	translate <0.52 0 0>
}

#declare X = object {
	intersection {
		union {
			quadric {
				Hor_Bar_2
				rotate <0 0 60>
				translate <0 0.52 0>
			}
			quadric {
				Hor_Bar_2
				rotate <0 0 -60>
				translate <0 0.52 0>
			}
		}
		plane { <0 1 0> 1 }
		plane { <0 -1 0> 0 }
	}
	bounded_by {
		sphere { <0.0 0.5 0> 0.65 }
	}
	translate <0.39 0 0>
}

#declare Y = object {
	intersection {
		union {
			intersection {
				quadric {
					Cylinder_Y
					scale <0.1 0.1 0.1>
				}
				plane { <0 1 0> 0.4 }
			}
			intersection {   //   /-segment
				quadric {
					Cylinder_X
					scale <0.1 0.1 0.1>
					rotate <0 0 65>
					translate <0 0.4 0>
				}
				plane { <-1 0 0> 0 }
			}
			intersection {   //   \-segment
				quadric {
					Cylinder_X
					scale <0.1 0.1 0.1>
					rotate <0 0 -65>
					translate <0 0.4 0>
				}
				plane { <1 0 0> 0 }
			}
		}
		plane { <0 1 0> 1 }
		plane { <0 -1 0> 0 }
	}
	bounded_by { sphere { <0.0 0.54 0> 0.7 } }
	translate <0.42 0 0>
}

#declare Z = object {
// Z - length 0.8082
	union {
		intersection {
			quadric {Cylinder_X scale <.1 .1 .1> translate <0 .1 0>}
			plane {<0.0 1.0 0.0> 0 rotate <0 0 30> translate <-0.4041 0 0>}
			plane {<1 0 0.0> 0.4030}
		}
		intersection {
			quadric {Cylinder_X scale <.1 .1 .1> translate <0 .9 0>}
			plane {<-1 0 0.0> 0.4030}
			plane {<0.0 -1.0 0.0> 0 rotate <0 0 30> translate <0.4041 1 0>}
		}
		intersection {
			quadric {Cylinder_Y scale <.1 .1 .1> rotate <0 0 -30> translate <0 .5 0> }
			plane {<0.0 -1.0 0.0> 0 rotate <0 0 30> translate <-0.4041 0 0>}
			plane {<0.0 1.0 0.0> 0 rotate <0 0 30> translate <0.4041 1 0>}
		}
	}
	bounded_by { sphere { <0.0 0.5 0> 0.64 } }
	translate <0.4041 0 0>
}
//////////////////////////////////////////////////
