// Example file for Reidar Husmo's alphabet.
// Shows the name of the rather self-centred author.
 
#include "colors.inc"
#include "textures.inc"
#include "shapes.inc"
#include "lettdefs.inc"

camera {
	location  <0.01  0.2 -1.8>
	look_at   <0  0  0.0>
	up        <0.0  1.0   0.0>
	right     <1.33 0.0   0.0>
}
object { light_source { <5 -10 -30> color White } }
object { light_source { <0 0 1> color White } }

#declare Persistence = composite {
	object {
		P
		texture { Gold_Texture }
		translate <0.0000 0 0>
	}
	object {
		E
		texture { Gold_Texture }
		translate <0.7125 0 0>
	}
	object {
		R
		texture { Gold_Texture }
		translate <1.4125 0 0>
	}
	object {
		S
		texture { Gold_Texture }
		translate <2.1250 0 0>
	}
	object {
		I
		texture { Gold_Texture }
		translate <2.8500 0 0>
	}
	object {
		S
		texture { Gold_Texture }
		translate <3.1500 0 0>
	}
	object {
		T
		texture { Gold_Texture }
		translate <3.8750 0 0>
	}
	object {
		E
		texture { Gold_Texture }
		translate <4.5750 0 0>
	}
	object {
		N
		texture { Gold_Texture }
		translate <5.2750 0 0>
	}
	object {
		C
		texture { Gold_Texture }
		translate <6.2750 0 0>
	}
	object {
		E
		texture { Gold_Texture }
		translate <7.1750 0 0>
	}
	translate <-3.88750 0 0> // centre around the y-axis
	scale <0.25723 0.25723 0.25723> // scale to unit length
	bounded_by {
		box { UnitBox translate <0 1 0> scale <1 0.12862 0.01286> }
	}
} // Accumulated length: 7.77500 half: 3.88750 inv: 0.128617

#declare Of = composite {
	object {
		O
		texture { Mirror }
		translate <0.0000 0 0>
	}
	object {
		F
		texture { Mirror }
		translate <0.9000 0 0>
	}
	translate <-0.75000 0 0> // centre around the y-axis
	scale <1.33333 1.33333 1.33333> // scale to unit length
	bounded_by {
		box { UnitBox translate <0 1 0> scale <1 0.66667 0.06667> }
	}
} // Accumulated length: 1.50000 half: 0.75000 inv: 0.666667

#declare Vision = composite {
	object {
		V
		texture { Gold_Texture }
		translate <0.0000 0 0>
	}
	object {
		I
		texture { Gold_Texture }
		translate <0.8400 0 0>
	}
	object {
		S
		texture { Gold_Texture }
		translate <1.1400 0 0>
	}
	object {
		I
		texture { Gold_Texture }
		translate <1.8650 0 0>
	}
	object {
		O
		texture { Gold_Texture }
		translate <2.1650 0 0>
	}
	object {
		N
		texture { Gold_Texture }
		translate <3.0650 0 0>
	}
	translate <-1.98250 0 0> // centre around the y-axis
	scale <0.50441 0.50441 0.50441> // scale to unit length
	bounded_by {
		box { UnitBox translate <0 1 0> scale <1 0.25221 0.02522> }
	}
} // Accumulated length: 3.96500 half: 1.98250 inv: 0.252207

composite {
	composite { Persistence translate <0 0.4 0> } // 0.25723
	composite { Of translate <0 -0.45727 2> }
	composite { Vision translate <0 -0.5 0> } // 0.50441
}
